#ifndef CKMeansH
#define CKMeansH

#include <vector>
#include <CVector.h>
#include "CMatching.h"

void kmeans(CVector<float>* aData, CVector<float>* aMean, float* aNum, CVector<int>& aLabels, CVector<int>& aLength, CVector<std::vector<float> >& g, CVector<std::vector<int> >& idx, int K, float aNu, CVector<int>& aNodeToIndex, std::vector<CTrack>& aTracks, int aXSize, int aYSize, int aSequenceLength);
float computeEnergy(CVector<float>* aData, CVector<float>* aMean, CVector<int>& aLabels, CVector<int>& aLength);
float computeEnergy(CVector<float>* aData, CVector<float>* aMean, CVector<int>& aLabels, CVector<int>& aLength, CVector<std::vector<float> >& g, CVector<std::vector<int> >& idx, float aNu);
void kmeansRecomputeStatistics(CVector<float>* aData, CVector<float>* aSum, float* aNum, CVector<int>& aLabels, CVector<int>& aLength, int K);

#endif

